// Copyright 2019 The TCMalloc Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#ifndef TCMALLOC_EXPERIMENT_CONFIG_H_
#define TCMALLOC_EXPERIMENT_CONFIG_H_

#include "absl/strings/string_view.h"

// Autogenerated by experiments_proto_test --experiments_generate_config=true
namespace tcmalloc {

enum class Experiment : int {
  TEST_ONLY_TCMALLOC_POW2_SIZECLASS,
  TEST_ONLY_TCMALLOC_SHARDED_TRANSFER_CACHE,
  TEST_ONLY_TCMALLOC_FILLER_CHUNKS_PER_ALLOC,
  TCMALLOC_SHORT_LONG_TERM_SUBRELEASE,
  TCMALLOC_WIDER_SLABS,
  TEST_ONLY_TCMALLOC_512K_SLAB,
  TEST_ONLY_TCMALLOC_USE_ALL_BUCKETS_FOR_FEW_OBJECT_SPANS_IN_CFL,
  TEST_ONLY_TCMALLOC_USE_EXTENDED_SIZE_CLASS_FOR_COLD,
  kMaxExperimentID,
};

struct ExperimentConfig {
  Experiment id;
  absl::string_view name;
};

// clang-format off
inline constexpr ExperimentConfig experiments[] = {
    {Experiment::TEST_ONLY_TCMALLOC_POW2_SIZECLASS, "TEST_ONLY_TCMALLOC_POW2_SIZECLASS"},
    {Experiment::TEST_ONLY_TCMALLOC_SHARDED_TRANSFER_CACHE, "TEST_ONLY_TCMALLOC_SHARDED_TRANSFER_CACHE"},
    {Experiment::TEST_ONLY_TCMALLOC_FILLER_CHUNKS_PER_ALLOC, "TEST_ONLY_TCMALLOC_FILLER_CHUNKS_PER_ALLOC"},
    {Experiment::TCMALLOC_SHORT_LONG_TERM_SUBRELEASE, "TCMALLOC_SHORT_LONG_TERM_SUBRELEASE"},
    {Experiment::TCMALLOC_WIDER_SLABS, "TCMALLOC_WIDER_SLABS"},
    {Experiment::TEST_ONLY_TCMALLOC_512K_SLAB, "TEST_ONLY_TCMALLOC_512K_SLAB"},
    {Experiment::TEST_ONLY_TCMALLOC_USE_ALL_BUCKETS_FOR_FEW_OBJECT_SPANS_IN_CFL, "TEST_ONLY_TCMALLOC_USE_ALL_BUCKETS_FOR_FEW_OBJECT_SPANS_IN_CFL"},
    {Experiment::TEST_ONLY_TCMALLOC_USE_EXTENDED_SIZE_CLASS_FOR_COLD, "TEST_ONLY_TCMALLOC_USE_EXTENDED_SIZE_CLASS_FOR_COLD"},
};
// clang-format on
}  // namespace tcmalloc

#endif  // TCMALLOC_EXPERIMENT_CONFIG_H_
